<?php

function contextly_overlay_editor_page($type) {
  print ContextlyDrupalKit::getInstance()
    ->newOverlayDialog($type)
    ->render();
}

function contextly_ajax_editor_request_callback($request, $node) {
  try {
    // Build parameters list.
    $params = $_POST;
    $params['custom_id'] = $node->nid;

    // Handle the request.
    $result = ContextlyDrupalKit::getInstance()
      ->newWidgetsEditor()
      ->handleRequest($request, $params);

    // Deliver results to the client.
    drupal_json_output($result);
  }
  catch (ContextlyKitException $e) {
    _contextly_watchdog_exception($e);
    _contextly_return_internal_error();
  }
}

function contextly_ajax_put_node_callback($node) {
  try {
    // Node update is allowed to everyone, so we use per-node lock to avoid high
    // server and Contextly load by parallel node views at the same time.
    $lock_name = "contextly-put-node:{$node->nid}";
    if (lock_acquire($lock_name)) {
      ContextlyDrupalKit::getInstance()
        ->newDrupalNodeEditor()
        ->putNode($node);
      lock_release($lock_name);
    }

    // Notify client about success, even on lock acquired by another request.
    drupal_json_output(array(
      'success' => TRUE,
    ));
  }
  catch (ContextlyKitException $e) {
    _contextly_watchdog_exception($e);
    _contextly_return_internal_error();
  }
}

function _contextly_return_internal_error() {
  drupal_add_http_header('Status', '500 Internal Server Error');
  drupal_exit();
}
